"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var AcFormErrors = (function () {
    function AcFormErrors(formDir) {
        this.formDir = formDir;
    }
    Object.defineProperty(AcFormErrors.prototype, "errorMessages", {
        get: function () {
            var form = this.formDir.form;
            var control = form.find(this.controlPath);
            var _errors = [];
            if (control !== undefined && control !== null && control.touched) {
                var errors = Object.keys(this.errorTypes);
                for (var i = 0; i < errors.length; ++i) {
                    var errorType = errors[i];
                    if (control.hasError(errorType)) {
                        _errors.push({
                            type: errorType,
                            message: this.errorTypes[errorType]
                        });
                    }
                }
            }
            return _errors;
        },
        set: function (value) {
        },
        enumerable: true,
        configurable: true
    });
    AcFormErrors = __decorate([
        core_1.Component({
            selector: 'ac-form-errors',
            inputs: [
                'controlPath: control',
                'errorTypes: errors'
            ],
            template: "\n    <span *ngFor=\"let error of errorMessages\">\n      <span>{{ error.message }}</span>\n    </span>\n  "
        }),
        __param(0, core_1.Host()), 
        __metadata('design:paramtypes', [forms_1.NgForm])
    ], AcFormErrors);
    return AcFormErrors;
}());
exports.AcFormErrors = AcFormErrors;
exports.ANGULARCLASS_FORM_ERRORS_DIRECTIVES = [
    AcFormErrors
];
//# sourceMappingURL=index.js.map